///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2017 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using System;

using com.espertech.esper.compat.logging;
using com.espertech.esper.core.service;

namespace com.espertech.esper.core.thread
{
    /// <summary>Inbound unit for unwrapped events. </summary>
    public class InboundUnitSendEvent
    {
        private static readonly ILog Log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private readonly Object _event;
        private readonly EPRuntimeImpl _runtime;

        /// <summary>Ctor. </summary>
        /// <param name="theEvent">to process</param>
        /// <param name="runtime">to process event</param>
        public InboundUnitSendEvent(Object theEvent, EPRuntimeImpl runtime)
        {
            _event = theEvent;
            _runtime = runtime;
        }

        public void Run()
        {
            try
            {
                _runtime.ProcessEvent(_event);
            }
            catch (Exception e)
            {
                Log.Error("Unexpected error processing unwrapped event: " + e.Message, e);
            }
        }
    }
}
